找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1775|回复: 3

[研讨] acedSSGet :KacedSSGet选择图元时使用关键词

[复制链接]

已领礼包: 112个

财富等级: 日进斗金

发表于 2019-7-12 22:39:41 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
This method allow a custom code to be executed when the user selects a keyword, which allow us include some additional keywords.
On the sample below, when acedSSGet() is called in a custom command, the user is able to use two new keywords: LInes to select all lines in the current drawing and CIRcles to select all circles. The callback function uses all possible return values.
First, check below the custom command, that register for the call back.
void MyCustomCommand()
{
  // save the old callback function
  resbuf* (*oldFunc) (const ACHAR*);
  acedSSGetKwordCallbackPtr(&oldFunc);
  // set own callback function
  acedSSSetKwordCallbackPtr(ssCallback);
  // let the user make a selection
  ads_name ss;
  // this is the keyword list
  // to use local and global keywords:
  ACHAR kwordlist[] = { _T("LInes CIRcles _ LInes CIRcles") };
  if (RTNORM != acedSSGet(_T("_:K"), NULL, kwordlist, NULL, ss)) {
    // cancel
  } else {
    acutPrintf(_T("\nDone."));
    acedSSFree(ss);
  }
  // restore old callback function
  acedSSSetKwordCallbackPtr(*oldFunc);
}

Now the callback that is executed when the keyword is selected:
// Callback function for acedSSGet()
resbuf* ssCallback(const TCHAR* kword)
{
  // kword contains the global keyword
  acutPrintf(_T("\nCallback: '%s'"), kword);
  // result to return
  // NULL: no changes on selection set
  resbuf *result = NULL;
  if (!wcscmp(kword, _T("LInes"))) {
    // select all lines (just for testing)
    AcDbObjectIdArray objIds;
    getLines(objIds);
    // create resbuf containing single
    // enames from object id array
    result = getResbuf(objIds);
  } else if (!wcscmp(kword, _T("CIRcles"))) {
    // select all circles (just for testing)
    AcDbObjectIdArray objIds;
    getCircles(objIds);
    // create resbuf containing a selection set
    ads_name ss;
    acedSSGet(_T("X"), NULL, NULL,
      acutBuildList(RTDXF0, _T("CIRCLE"), RTNONE),
      ss);
    result = acutBuildList(RTPICKS, ss, RTNONE);
  } else {
    // return an error message
    result = acutBuildList(RTSTR, _T("\nUnknown error"), RTNONE);
  }
  return result;
}

And finally some additional methods for this specific sample:
resbuf* getResbuf(AcDbObjectIdArray ids)
{
  resbuf *result = NULL, *temp1, *temp2;
  ads_name ename;
  int length = ids.length();
  for (int i = 0; i < length; ++i) {
    acdbGetAdsName(ename, ids);
    temp2 = acutBuildList(RTENAME, ename, RTNONE);
    if (result == NULL) {
      result = temp2;
    } else {
      temp1->rbnext = temp2;
    }
    temp1 = temp2;
  }
  return result;
}
void getLines(AcDbObjectIdArray& ids)
{
  // select all lines from model space
  // (without any error checking)
  AcDbBlockTable *pTable;
  AcDbBlockTableRecord *pModelSpace;
  AcDbBlockTableRecordIterator *pIter;
  AcDbEntity* pEnt;
  acdbHostApplicationServices()->workingDatabase()->
    getBlockTable(pTable, AcDb::kForRead);
  pTable->getAt(ACDB_MODEL_SPACE, pModelSpace, AcDb::kForRead);
  pTable->close();
  pModelSpace->newIterator(pIter);
  pModelSpace->close();
  for (; !pIter->done(); pIter->step()) {
    pIter->getEntity(pEnt, AcDb::kForRead);
    if (pEnt->isKindOf(AcDbLine::desc()))
      ids.append(pEnt->objectId());
    pEnt->close();
  }
  delete pIter;
}
void getCircles(AcDbObjectIdArray& ids)
{
  // select all circles from model space
  // (without any error checking)
  AcDbBlockTable *pTable;
  AcDbBlockTableRecord *pModelSpace;
  AcDbBlockTableRecordIterator *pIter;
  AcDbEntity* pEnt;
  acdbHostApplicationServices()->workingDatabase()->
    getBlockTable(pTable, AcDb::kForRead);
  pTable->getAt(ACDB_MODEL_SPACE, pModelSpace, AcDb::kForRead);
  pTable->close();
  pModelSpace->newIterator(pIter);
  pModelSpace->close();
  for (; !pIter->done(); pIter->step()) {
    pIter->getEntity(pEnt, AcDb::kForRead);
    if (pEnt->isKindOf(AcDbCircle::desc()))
      ids.append(pEnt->objectId());
    pEnt->close();
  }
  delete pIter;
}

以上为ObjectARX示例的acedSSGet使用K模式的示例,
void MyCustomCommand()
{
  // save the old callback function
  resbuf* (*oldFunc) (const ACHAR*);
  acedSSGetKwordCallbackPtr(&oldFunc);
  // set own callback function
  acedSSSetKwordCallbackPtr(ssCallback);
  // let the user make a selection
  ads_name ss;
  // this is the keyword list
  // to use local and global keywords:
  ACHAR kwordlist[] = { _T("LInes CIRcles _ LInes CIRcles") };
  if (RTNORM != acedSSGet(_T("_:K"), NULL, kwordlist, NULL, ss)) {
    // cancel
  } else {
    acutPrintf(_T("\nDone."));
    acedSSFree(ss);
  }
  // restore old callback function
  acedSSSetKwordCallbackPtr(*oldFunc);
}
现在想知道,当选择时不输入关键词,而是正常选择图元后,如何获取选择集ss?若输入了关键词,如LInes,ssCallback中的
AcDbObjectIdArray objIds;
    getLines(objIds);
    // create resbuf containing single
    // enames from object id array
    result = getResbuf(objIds);
返回值result从哪里可以获取到?

正常情况下acedSSGet获取到选择集后,都是要对选择集进行处理的,请问选择集处理相关部分代码应该加在哪里?


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 960个

财富等级: 财运亨通

发表于 2019-7-13 22:44:11 | 显示全部楼层
谢谢分享,尝试一下
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2019-7-14 15:22:07 | 显示全部楼层
if (RTNORM != acedSSGet(_T("_:K"), NULL, kwordlist, NULL, ss)) {
    // cancel
  } else {
    acutPrintf(_T("\nDone."));
//无论是否使用关键字,这里返回ss的就是结果的选择集
//这个关键字的例子类似添加过滤,
    acedSSFree(ss);
  }

点评

请问用了关键字后,在关键字调用中继续使用了acedssget,获取到的图元会在ss的选择集中返回吗?  详情 回复 发表于 2019-7-15 08:58
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 112个

财富等级: 日进斗金

 楼主| 发表于 2019-7-15 08:58:25 | 显示全部楼层
本帖最后由 革天明 于 2019-7-15 09:02 编辑
edata 发表于 2019-7-14 15:22
if (RTNORM != acedSSGet(_T("_:K"), NULL, kwordlist, NULL, ss)) {
    // cancel
  } else {

谢谢,我试试
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-22 04:44 , Processed in 0.215782 second(s), 37 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表